#include <stdio.h>
#include <stdlib.h> 
#include "ruby.h"
#include "fun.h"

static int id_fun;

static VALUE wrap_fun(VALUE cl) {
    printf("call rb_funcall\n");
    return rb_funcall(cl, id_fun, 0);
}

static VALUE RB_add_in_c(VALUE cl, VALUE a_val, VALUE b_val) {
    int a, b, sum;
    a = NUM2INT(a_val);
    b = NUM2INT(b_val);
    sum = c_add_in_c(a, b);
    return INT2NUM(sum);
}

static VALUE RB_add_in_f(VALUE cl, VALUE a_val, VALUE b_val) {
    int a, b, sum;
    a = NUM2INT(a_val);
    b = NUM2INT(b_val);
    sum = c_add_in_f(a, b);
    return INT2NUM(sum);
}

void START() {
    printf("call ruby_init\n");
    ruby_init(); // initializes the interpreter
    printf("call ruby_init_loadpath\n");
    ruby_init_loadpath(); // initializes the $: variable
    printf("call ruby_script\n");
    ruby_script("stella"); // assigns the name of this script to the $0 variable
    printf("call rb_require\n");
    rb_require("fun.rb"); // load the Ruby command file
    printf("call rb_class_new_instance\n");
    VALUE fun_cl = rb_const_get(rb_cObject, rb_intern("FunTest"));
    VALUE cl = rb_class_new_instance(0, 0, fun_cl);
    printf("call rb_define_method\n");
    rb_define_method(fun_cl, "add_in_c", RB_add_in_c, 2);
    printf("call rb_define_method\n");
    rb_define_method(fun_cl, "add_in_f", RB_add_in_f, 2);
    printf("call rb_intern\n");
    id_fun = rb_intern("fun");
    int error;
    printf("call rb_protect\n");
    VALUE result = rb_protect(wrap_fun, cl, &error);
    if (error) printf("Error return from call on wrap_fun\n");
    printf("call ruby_finalize\n");
    ruby_finalize(); // shut down
}
