/* cfun_select.c */

#include <stdio.h>
#include <stdlib.h> 
#include "cfortran.h"
#include "fun.h"

/* Passing C or Fortran Functions to Fortran routines. */
PROTOCCALLSFFUN3(INT,C2F_FUNADD,c2f_funadd,ROUTINE,INT,INT)
#define C2F_FUNADD(F,A,B) CCALLSFFUN3(C2F_FUNADD,c2f_funadd, ROUTINE, INT, INT, F, A, B)

int Cadd(a,b) int a; int b; {return a+b;}
FCALLSCFUN2(INT,Cadd,CADD,cadd, INT, INT)

int c_add_in_c(int a, int b) {
    int sum = C2F_FUNADD(C_FUNCTION(CADD,cadd),1,2);
    printf("\nExample of passing a C function to a Fortran routine\n");
    printf("FUNADD(CADD,1,2) returns %d\n", sum);
    return sum;
}

/* Want fadd to be prototyped, though don't need the wrapper that is created. */
PROTOCCALLSFFUN2(INT,C2F_FADD,c2f_fadd,INT,INT)

int c_add_in_f(int a, int b) {
    int sum = C2F_FUNADD(FORTRAN_FUNCTION(C2F_FADD,c2f_fadd),3,4);
    printf("\nExample of passing a Fortran function to a Fortran routine\n");
    printf("FUNADD(FADD,3,4) returns %d\n", sum);
    return sum;
}
