      module ffun_data_mod
      
      implicit none
      
      integer, parameter :: N_mesh=502	! number of mesh points (will discard 1st and last when save)
      
      double precision, DIMENSION(N_mesh) :: XI
      double precision, DIMENSION(4,N_mesh) :: YOUT, YIN
      
      integer, parameter :: N_IONs = 4 ! number of ion mass fractions
      ! for now just h, he, c, and o for testing purposes
      integer, parameter :: ih1  = 1
      integer, parameter :: ihe4 = 2
      integer, parameter :: ic12 = 3
      integer, parameter :: io16 = 4
      
      double precision :: mass_fractions(N_IONs) ! the (uniform) composition for the star
      double precision :: ymass(N_IONs) ! molar abundances
      double precision :: abar ! mean number of nucleons
      double precision :: zbar ! mean nucleon charge
      double precision :: zion(N_IONs) ! 1 for H1, 2 for He4, 6 for C12, 8 for O16, etc.
      double precision :: aion(N_IONs) ! 1 for H1, 4 for He4, 12 for C12, 16 for O16, etc.
      
      double precision, dimension(:), pointer :: test_mass_fractions
      
      end module ffun_data_mod